{*******************************************************************************}
{                                                                               }
{  SdStopWatch.pas   Ver1.00  2004.6.29.                                        }
{                                                                               }
{===============================================================================}
{                                                                               }
{  Archive           StopWatchComp.exe                                        @}
{                                                                               }
{  Components        TSdStopWatch Ver1.00                                       }
{                                                                               }
{  Compiler          Delphi3, 6 and 7, Although 4 and 5                         }
{                                                                               }
{  CopyRight @ (C)2004/2004 Hiroshi Sadoyama(nR ) All Rights reserved    }
{                                                                         @@@}
{  FirstUpDate        2004.7.02.                                           @@@}
{                                                                         @@@}
{  FreeWare          pEƖp܂߁AgpERs[EzzEEfړR   }
{  AoOR[ȟȂǂwEΏ܂B           @@@@}
{  ܂Aǂꂽ́A׋̂ߎɂ\[X𒸂ƍKłB @@@@@@}
{                                                                         @@@}
{  URL: sadoyama.pro.nu    Mail: sadoyama@pro.nu (2004.7)             @@@}
{                                                                               }
{*******************************************************************************}


unit SdStopWatch;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, ExtCtrls,
  Graphics, Dialogs, Forms;

type
  TSdStopWatch = class(TPanel)
  private
    { Private 錾 }
    FTimer: TTimer;
    flgNoCounter: Boolean; // xptH[}XJE^
    StartTime: Int64;      // vJñJE^l
    Frequency: Int64;      // CPU̎g
    procedure SetTimer(const Value: TTimer);
    // FTimerOnEvent
    procedure EventOnTimer(Sender: TObject);
    // StopTime - StartTime \
    procedure TimeCountToStr(Time: Int64);
    property Timer: TTimer read  FTimer
                           write SetTimer;
  protected
    { Protected 錾 }
    // TTimer̔j󂯎
    procedure Notification(AComponent: TComponent;
                           Operation: TOperation); override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    // ǉJ\bh
    procedure Clear;
    procedure Start;
    procedure Stop;
  published
    { Published 錾 }
  end;

// l̑O'0'ĕ\
function  IntToLeft0Str(Number, Digit: Integer): String;
procedure Register;

const
  Interval = 90;  // FTimer.Interval

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TSdStopWatch]);
end;

{ TSdStopWatch }

constructor TSdStopWatch.Create(AOwner: TComponent);
begin
  // CPU̎g𓾂
  if not QueryPerformanceFrequency(Frequency) then
    flgNoCounter := true;

  inherited;
  Height := 24;
  Width := 124;
  BevelInner := bvLowered;
  Caption := '0:00:00: 000:000';
  Color := clWhite;
  Font.Size := 10;
  Font.Style := [fsBold];

  FTimer := TTimer.Create(Self);
  FTimer.Interval := 0;
  // sȂCxgnhȂ
  if not (csDesigning in ComponentState) then
    FTimer.OnTimer := EventOnTimer;
end;

destructor TSdStopWatch.Destroy;
begin
  FTimer.Free;
  inherited;
end;

{ TTimer ̑gݍ }

procedure TSdStopWatch.SetTimer(const Value: TTimer);
begin
  // if Assigned(FFocusControl) then ł
  if FTimer <> nil then  FTimer.RemoveFreeNotification(self);
  FTimer := Value;
  // R|[lg̔jʒmTSdStopWatchɈ˗
  if FTimer <> nil then  FTimer.FreeNotification(self);
end;

// Timer̔ǰo
procedure TSdStopWatch.Notification
            (AComponent: TComponent; Operation: TOperation);
begin
  inherited;
  if Operation = opRemove then  // opRemove = jꂽ
    // jꂽ̂TimermF
    if AComponent = Timer then
      // TSdStopWatchjꂽ烊N؂
      FTimer := nil;
end;

// TimerOnTimerCxg
procedure TSdStopWatch.EventOnTimer;
var
  StopTime: Int64;
begin
  QueryPerformanceCounter(StopTime);
  TimeCountToStr(StopTime);
end;

{ ǉ̌J\bh }

procedure TSdStopWatch.Clear;
begin
  if flgNoCounter then   Exit;
  Caption := '0:00:00: 000:000';
end;

procedure TSdStopWatch.Start;
begin
  // xptH[}XJE^ȂPC݂͑ȂƎv
  // MSDN̒ӏɏ]Ô
  if flgNoCounter then
  begin
    Showmessage('ӁFprocedure Start in SdStopWatch.pas'
                + #13#10 +
                '̋@͍xptH[}XJE^' +
                'Ȃ߁ASdStopWatchgpł܂B');
    Exit;
  end;

  Clear;
  FTimer.Interval := Interval;       // Gloval const
  Application.ProcessMessages;
  QueryPerformanceCounter(StartTime);
end;

procedure TSdStopWatch.Stop;
var
  LastTime: Int64;
begin
  if flgNoCounter then  Exit;

  QueryPerformanceCounter(LastTime);
  FTimer.Interval := 0;

  // J\bh LastTime - StartTime \
  TimeCountToStr(LastTime);
end;

{ Jc[\bh }

// StopTime - StartTime \
procedure TSdStopWatch.TimeCountToStr(Time: Int64);
var
  LapTime, TempTime: Int64;
  h: Int64;
  m, s, Milli, Micro: Integer;
begin
  // }CNbPʂœ
  LapTime := Round((Time - StartTime) / Frequency * 1000000);

  // 60 * 60b * 1000~b * 1000}CNb;
  TempTime := 3600000000;
  h := LapTime div TempTime;

  m := (LapTime mod TempTime) div (60 * 1000 * 1000);
  s := (LapTime mod (1000 * 1000 * 60)) div (1000 * 1000);
  Milli := (LapTime mod (1000 * 1000)) div 1000;
  Micro := LapTime mod 1000;

  Caption := IntToStr(h) + ':' + IntToLeft0Str(m, 2) + ':' +
             IntToLeft0Str(s, 2) + ': ' +
             IntToLeft0Str(Milli, 3) + ':' +
             IntToLeft0Str(Micro, 3);
end;

// l̑O'0'ĕ\
function IntToLeft0Str(Number, Digit: Integer): String;
var
  i, j: Integer;
  S: String;
begin
  S := IntToStr(Number);
  j := Length(S);
  if j > Digit then
  begin
    Showmessage('G[FIntToLeft0Str֐ in' +
                ' SdStopWatch.pas' + #13#10 +
                'lw肳ꂽ𒴂Ă܂B');
    Exit;
  end;

  j := Digit - j;
  if j <> 0 then
    for i := 1 to j do
      S := '0' + S;
  Result := S;
end;

end.

